Filebench - A Model Based File System Workload Generator
========================================================

* Usage

filebench binary allows to run individual workload personalities. Below is
an example of individual varmail workload run:

shell# filebench
filebench> load varmail
 8395: 3.898: Varmail personality successfully loaded
 8395: 3.899: Usage: set $dir=<dir>
 8395: 3.900:        set $filesize=<size>    defaults to 16384
 8395: 3.900:        set $nfiles=<value>     defaults to 1000
 8395: 3.901:        set $dirwidth=<value>   defaults to 20
 8395: 3.901:        set $nthreads=<value>   defaults to 1
 8395: 3.902:        set $meaniosize=<value> defaults to 16384
 8395: 3.902:        run <runtime>
filebench> set $dir=/tmp
filebench> run 10
 8395: 14.886: Fileset mailset: 1000 files, avg dir = 20, avg depth = 2.305865, mbytes=15
 8395: 15.301: Preallocated fileset mailset in 1 seconds
 8395: 15.301: Starting 1 filereader instances
 8396: 16.313: Starting 1 filereaderthread threads
 8395: 19.323: Running for 10 seconds...
 8395: 29.333: Stats period = 10s
 8395: 29.347: IO Summary:      21272 iops 2126.0 iops/s, (1063/1063 r/w)  32.1mb/s,    338us cpu/op,   0.3ms latency
 8395: 29.348: Shutting down processes
filebench> quit

* Peculiarities

If you get an ENOMEM error on pthread_create() and you use a thread model,
there is a chance that Filebench runs out of virtual memory. E.g., under OLTP
workload we have more than 400 threads (200 processes, each has 2 threads,
where one thread is a control thread). By default NPTL mmaps current stack
ulimit bytes for each thread, which is 8MB by default on Linux. So, in total
this process uses 400 \* 8MB = 3.2G, which is more than a process can address
on Linux.

One workaround is to set stack ulimit to unlimited, which will cause NPTL to
use only 2MB of mmaped memory for each thread.  Notice, that you need to set
ulimit in the shell, which invokes the executable. It won't help you doing it
in the main() function, because NTPL reads the ulimits before main() is
invoked.

*  New features added to this port

You can define position sets:

  define posset name=myposset,entries=50,type=rnd,max=7516192768,seed=2 

This will create a possition set of 50 entries. Each position
will be generated using rand() function with seed 2 and will
be in the range [0 - 7516192768]. We round every generated
position to 512 at the moment.

After position set is defined, it can be attributed to a read or write flowop:

 flowop write name=myfop,filesetname=myfst,possetname=myposset,random,iosize=2k

In this case, every write will happen at the position randomly selected from
the position set.  Important to notice, that both possetname and random
attributes must be specified. If only possetname is specified, it is
ignored.

===========================================================

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.

# Sequential write() of a 1G file, size picked from a table in
# the [1K,64K] range with a mean of 5.5K, followed by close(), cached.



set $dir=/tmp
set $nthreads=1
set $cached=false
set $sync=false
set $count=128k

define randvar name=$iosize, type=tabular, min=1k, randtable =
{{ 80, 1k, 4k},
 { 15, 4k, 16k},
 { 05, 16k, 64k}}

define fileset name=bigfileset,path=$dir,size=0,entries=$nthreads,dirwidth=1024,prealloc=100,cached=$cached

define process name=filewriter,instances=1
{
  thread name=filewriterthread,memsize=10m,instances=$nthreads
  {
    flowop openfile name=open-file,filesetname=bigfileset,fd=1
    flowop appendfile name=write-file,dsync=$sync,iosize=$iosize,fd=1,iters=$count
    flowop closefile name=close,fd=1
    flowop finishoncount name=finish,value=1
  }
}

echo  "FileMicro-SeqWriteRandVarTab Version 1.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$cached=<bool>        defaults to $cached"
usage "       set \$count=<value>        defaults to $count"
usage "       set \$iosize.type=<type>   defaults to $iosize.type"
usage "       set \$iosize.randsrc=<src> defaults to $iosize.randsrc"
usage "       set \$iosize.mean=<mean>   defaults to $iosize.mean"
usage "       set \$iosize.gamma=<gamma> defaults to $iosize.gamma"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage "       set \$sync=<bool>          defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# $dir - directory for datafiles
# $eventrate - event generator rate (0 == free run)
# $nfiles - number of data files
# $nthreads - number of worker threads

set $dir=/tmp
set $cached=false
set $eventrate=10
set $meandirwidth=20
set $nthreads=1
set $nfiles=100000
set $sync=false

eventgen rate=$eventrate

define randvar name=$wrtiosize, type=tabular, min=1k, round=1k, randtable =
{{ 0,   1k,    7k},
 {50,   9k,   15k},
 {14,  17k,   23k},
 {14,  33k,   39k},
 {12,  65k,   71k},
 {10, 129k,  135k}
}

define randvar name=$rdiosize, type=tabular, min=8k, round=1k, randtable =
{{85,   8k,   8k},
 { 8,  17k,  23k},
 { 4,  33k,  39k},
 { 2,  65k,  71k},
 { 1, 129k, 135k}
}

define randvar name=$filesize, type=tabular, min=1k, round=1k, randtable =
{{33,   1k,    1k},
 {21,   1k,    3k},
 {13,   3k,    5k},
 {10,   5k,   11k},
 {08,  11k,   21k},
 {05,  21k,   43k},
 {04,  43k,   85k},
 {03,  85k,  171k},
 {02, 171k,  341k},
 {01, 341k, 1707k}
}

define randvar name=$fileidx, type=gamma, min=0, gamma=100

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=60,cached=$cached

define flowop name=rmw, $filesetrmw
{
  flowop openfile name=openfile1,filesetname=$filesetrmw,indexed=$fileidx,fd=1
  flowop readwholefile name=readfile1,iosize=$rdiosize,fd=1
  flowop createfile name=newfile2,filesetname=$filesetrmw,indexed=$fileidx,fd=2
  flowop writewholefile name=writefile2,fd=2,iosize=$wrtiosize,srcfd=1
  flowop closefile name=closefile1,fd=1
  flowop closefile name=closefile2,fd=2
  flowop deletefile name=deletefile1,fd=1
}

define flowop name=launch, $filesetlch
{
  flowop openfile name=openfile3,filesetname=$filesetlch,indexed=$fileidx,fd=3
  flowop readwholefile name=readfile3,iosize=$rdiosize,fd=3
  flowop openfile name=openfile4,filesetname=$filesetlch,indexed=$fileidx,fd=4
  flowop readwholefile name=readfile4,iosize=$rdiosize,fd=4
  flowop closefile name=closefile3,fd=3
  flowop openfile name=openfile5,filesetname=$filesetlch,indexed=$fileidx,fd=5
  flowop readwholefile name=readfile5,iosize=$rdiosize,fd=5
  flowop closefile name=closefile4,fd=4
  flowop closefile name=closefile5,fd=5
}

define flowop name=appnd, $filesetapd
{
  flowop openfile name=openfile6,filesetname=$filesetapd,indexed=$fileidx,fd=6
  flowop appendfilerand name=appendfilerand6,iosize=$wrtiosize,fd=6
  flowop closefile name=closefile6,fd=6
}

define process name=netclient,instances=1
{
  thread name=fileuser,memsize=10m,instances=$nthreads
  {
    flowop launch name=launch1, iters=1, $filesetlch=bigfileset
    flowop rmw name=rmw1, iters=6, $filesetrmw=bigfileset
    flowop appnd name=appnd1, iters=3, $filesetapd=bigfileset
    flowop statfile name=statfile1,filesetname=bigfileset,indexed=$fileidx
    flowop eventlimit name=ratecontrol
  }
}

echo  "NetworkFileServer Version 1.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>            defaults to $dir"
usage "       set \$cached=<bool>        defaults to $cached"
usage "       set \$eventrate=<value>    defaults to $eventrate"
usage "       set \$wrtiosize.type=<type>   defaults to $wrtiosize.type"
usage "       set \$wrtiosize.randsrc=<src> defaults to $wrtiosize.randsrc"
usage "       set \$rdiosize.type=<type>   defaults to $rdiosize.type"
usage "       set \$rdiosize.randsrc=<src> defaults to $rdiosize.randsrc"
usage "       set \$filesize.type=<type>   defaults to $filesize.type"
usage "       set \$filesize.randsrc=<src> defaults to $filesize.randsrc"
usage "       set \$nfiles=<value>       defaults to $nfiles"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage "       set \$sync=<bool>          defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded random reads (2KB I/Os) on a 1GB file.
# Stops after 128MB ($bytes) has been read.

set $dir=/tmp
set $bytes=128m
set $cached=false
set $filesize=1g
set $iosize=2k
set $iters=1
set $nthreads=1

define file name=bigfile1,path=$dir,size=$filesize,prealloc,reuse,cached=$cached

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop read name=write-file,filesetname=bigfile1,random,iosize=$iosize,iters=$iters
    flowop finishonbytes name=finish,value=$bytes
  }
}

echo  "FileMicro-ReadRand Version 2.2 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$bytes=<value>     defaults to $bytes"
usage "       set \$cached=<bool>     defaults to $cached"
usage "       set \$filesize=<size>   defaults to $filesize"
usage "       set \$iters=<value>     defaults to $iters"
usage "       set \$iosize=<size>     defaults to $iosize"
usage "       set \$nthreads=<value>  defaults to $nthreads"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $nfiles=1000
set $meandirwidth=20
set $meanfilesize=16k
set $nthreads=100
set $iosize=1m
set $meanappendsize=16k

define fileset name=bigfileset,path=$dir,size=$meanfilesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=100
define fileset name=logfiles,path=$dir,size=$meanfilesize,entries=1,dirwidth=$meandirwidth,prealloc

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop openfile name=openfile1,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile1,fd=1,iosize=$iosize
    flowop closefile name=closefile1,fd=1
    flowop openfile name=openfile2,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile2,fd=1,iosize=$iosize
    flowop closefile name=closefile2,fd=1
    flowop openfile name=openfile3,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile3,fd=1,iosize=$iosize
    flowop closefile name=closefile3,fd=1
    flowop openfile name=openfile4,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile4,fd=1,iosize=$iosize
    flowop closefile name=closefile4,fd=1
    flowop openfile name=openfile5,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile5,fd=1,iosize=$iosize
    flowop closefile name=closefile5,fd=1
    flowop openfile name=openfile6,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile6,fd=1,iosize=$iosize
    flowop closefile name=closefile6,fd=1
    flowop openfile name=openfile7,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile7,fd=1,iosize=$iosize
    flowop closefile name=closefile7,fd=1
    flowop openfile name=openfile8,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile8,fd=1,iosize=$iosize
    flowop closefile name=closefile8,fd=1
    flowop openfile name=openfile9,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile9,fd=1,iosize=$iosize
    flowop closefile name=closefile9,fd=1
    flowop openfile name=openfile10,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile10,fd=1,iosize=$iosize
    flowop closefile name=closefile10,fd=1
    flowop appendfilerand name=appendlog,filesetname=logfiles,iosize=$meanappendsize,fd=2
  }
}

echo  "Web-server Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$meanfilesize=<size>   defaults to $meanfilesize"
usage "       set \$nfiles=<value>    defaults to $nfiles"
usage "       set \$meandirwidth=<value>  defaults to $meandirwidth"
usage "       set \$nthreads=<value>  defaults to $nthreads"
usage "       set \$iosize=<size>     defaults to $iosize"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.

set $dir=/tmp
set $nfiles=700
set $meandirwidth=20
set $filesize=128k
set $nthreads=10
set $meaniosize=16k

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=80, paralloc

define fileset name=u2fileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=80, paralloc

define fileset name=u3fileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=80, paralloc

define flowop name=readwrite, $fileset
{
  flowop openfile name=openfile4,filesetname=$fileset,fd=1
  flowop openfile name=openfile5,filesetname=$fileset,fd=2
  flowop readwholefile name=readfile1,fd=1
  flowop writewholefile name=writefile1,fd=2,srcfd=1
  flowop closefile name=closefile4,fd=1
  flowop closefile name=closefile5,fd=2
}

define flowop name=dowork, $filesetnm, $rwiters
{
  flowop createfile name=createfile1,filesetname=$filesetnm,fd=1
  flowop appendfilerand name=appendfilerand1,iosize=$meaniosize,fd=1
  flowop closefile name=closefile1,fd=1
  flowop readwrite name=rw1, iters=$rwiters, $fileset=$filesetnm
  flowop deletefile name=deletefile1,filesetname=$filesetnm
  flowop statfile name=statfile1,filesetname=$filesetnm
}

define process name=filereader1,instances=1
{
  thread name=user1,memsize=10m,instances=$nthreads
  {
    flowop dowork name=dowork1, iters=1, $rwiters=5, $filesetnm=bigfileset
  }

  thread name=user2,memsize=10m,instances=$nthreads
  {
    flowop dowork name=dowork2, iters=1, $rwiters=4, $filesetnm=u2fileset
  }

  thread name=user3,memsize=10m,instances=$nthreads
  {
    flowop dowork name=dowork3, iters=1, $rwiters=3, $filesetnm=u3fileset
  }
}

echo  "CompFlow_Demo Version 1.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>          defaults to $dir"
usage "       set \$filesize=<size>    defaults to $filesize"
usage "       set \$nfiles=<value>     defaults to $nfiles"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       set \$meaniosize=<value> defaults to $meaniosize"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "(sets mean dir width and dir depth is calculated as log (width, nfiles)"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# This workloads emulates a video server. It has two filesets, one of videos
# being actively served, and one of videos availabe but currently inactive
# (passive). However, one thread, vidwriter, is writing new videos to replace
# no longer viewed videos in the passive set. Meanwhile $nthreads threads are
# serving up videos from the activevids fileset. If the desired rate is R mb/s,
# and $nthreads is set to T, then set the $srvbwrate to R * T to get the
# desired rate per video stream. The video replacement rate of one video
# file per replacement interval, is set by $repintval which defaults to
# 10 seconds. Thus the write bandwidth will be set as $filesize/$repintval.
#

set $dir=/tmp
set $eventrate=96
set $filesize=10g
set $nthreads=48
set $numactivevids=32
set $numpassivevids=194
set $reuseit=false
set $readiosize=256k
set $writeiosize=1m

set $passvidsname=passivevids
set $actvidsname=activevids

set $repintval=10

eventgen rate=$eventrate

define fileset name=$actvidsname,path=$dir,size=$filesize,entries=$numactivevids,dirwidth=4,prealloc,paralloc,reuse=$reuseit
define fileset name=$passvidsname,path=$dir,size=$filesize,entries=$numpassivevids,dirwidth=20,prealloc=50,paralloc,reuse=$reuseit

define process name=vidwriter,instances=1
{
  thread name=vidwriter,memsize=10m,instances=1
  {
    flowop deletefile name=vidremover,filesetname=$passvidsname
    flowop createfile name=wrtopen,filesetname=$passvidsname,fd=1
    flowop writewholefile name=newvid,iosize=$writeiosize,fd=1,srcfd=1
    flowop closefile name=wrtclose, fd=1
    flowop delay name=replaceinterval, value=$repintval
  }
}

define process name=vidreaders,instances=1
{
  thread name=vidreaders,memsize=10m,instances=$nthreads
  {
    flowop read name=vidreader,filesetname=$actvidsname,iosize=$readiosize
    flowop bwlimit name=serverlimit, target=vidreader
  }
}

echo  "Video Server Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>              defaults to $dir"
usage "       set \$eventrate=<value>      defaults to $eventrate"
usage "       set \$filesize=<size>        defaults to $filesize"
usage "       set \$nthreads=<value>       defaults to $nthreads"
usage "       set \$writeiosize=<value>    defaults to $writeiosize"
usage "       set \$readiosize=<value>     defaults to $readiosize"
usage "       set \$numactivevids=<value>  defaults to $numactivevids"
usage "       set \$numpassivevids=<value> defaults to $numpassivevids"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded asynchronous ($sync) random appends (random I/Os
# in the range of [1B - 1MB]) to a 1GB file.
# Does a fsync after 10 ($iters) appends.
# Stops after 1GB ($bytes) has been appended/written.

set $dir=/tmp
set $bytes=1g
set $iosize=1m
set $iters=10
set $nthreads=1
set $sync=false

define file name=largefile,path=$dir,size=0,prealloc

define process name=filecreater,instances=1
{
  thread name=filecreaterthread,memsize=10m,instances=$nthreads
  {
    flowop appendfilerand name=append-file,filename=largefile,dsync=$sync,iosize=$iosize,iters=$iters
    flowop fsync name=sync
    flowop finishonbytes name=finish,value=$bytes
  }
}

echo  "FileMicro-CreateRand Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$bytes=<value>    defaults to $bytes"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$iters=<value>    defaults to $iters"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage "       set \$sync=<bool>      defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# $dir - directory for datafiles
# $eventrate - event generator rate (0 == free run)
# $nfiles - number of data files
# $nthreads - number of worker threads

set $dir=/tmp
set $cached=false
set $eventrate=10
set $meandirwidth=20
set $nthreads=1
set $nfiles=10000
set $sync=false
set $totalfiles=$nfiles * $eventrate

eventgen rate=$eventrate

define randvar name=$wrtiosize, type=tabular, min=1k, round=1k, randtable =
{{ 0,   1k,    7k},
 {50,   9k,   15k},
 {14,  17k,   23k},
 {14,  33k,   39k},
 {12,  65k,   71k},
 {10, 129k,  135k}
}

define randvar name=$rdiosize, type=tabular, min=8k, round=1k, randtable =
{{85,   8k,   8k},
 { 8,  17k,  23k},
 { 4,  33k,  39k},
 { 2,  65k,  71k},
 { 1, 129k, 135k}
}

define randvar name=$filesize, type=tabular, min=1k, round=1k, randtable =
{{33,   1k,    1k},
 {21,   1k,    3k},
 {13,   3k,    5k},
 {10,   5k,   11k},
 {08,  11k,   21k},
 {05,  21k,   43k},
 {04,  43k,   85k},
 {03,  85k,  171k},
 {02, 171k,  341k},
 {01, 341k, 1707k}
}

define randvar name=$fileidx, type=gamma, min=0, gamma=100

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$totalfiles,dirwidth=$meandirwidth,prealloc=60,cached=$cached

define flowop name=rmw, $filesetrmw
{
  flowop openfile name=openfile1,filesetname=$filesetrmw,indexed=$fileidx,fd=1
  flowop readwholefile name=readfile1,iosize=$rdiosize,fd=1
  flowop createfile name=newfile2,filesetname=$filesetrmw,indexed=$fileidx,fd=2
  flowop writewholefile name=writefile2,fd=2,iosize=$wrtiosize,srcfd=1
  flowop closefile name=closefile1,fd=1
  flowop closefile name=closefile2,fd=2
  flowop deletefile name=deletefile1,fd=1
}

define flowop name=launch, $filesetlch
{
  flowop openfile name=openfile3,filesetname=$filesetlch,indexed=$fileidx,fd=3
  flowop readwholefile name=readfile3,iosize=$rdiosize,fd=3
  flowop openfile name=openfile4,filesetname=$filesetlch,indexed=$fileidx,fd=4
  flowop readwholefile name=readfile4,iosize=$rdiosize,fd=4
  flowop closefile name=closefile3,fd=3
  flowop openfile name=openfile5,filesetname=$filesetlch,indexed=$fileidx,fd=5
  flowop readwholefile name=readfile5,iosize=$rdiosize,fd=5
  flowop closefile name=closefile4,fd=4
  flowop closefile name=closefile5,fd=5
}

define flowop name=appnd, $filesetapd
{
  flowop openfile name=openfile6,filesetname=$filesetapd,indexed=$fileidx,fd=6
  flowop appendfilerand name=appendfilerand6,iosize=$wrtiosize,fd=6
  flowop closefile name=closefile6,fd=6
}

define process name=netclient,instances=1
{
  thread name=fileuser,memsize=10m,instances=$nthreads
  {
    flowop launch name=launch1, iters=1, $filesetlch=bigfileset
    flowop rmw name=rmw1, iters=6, $filesetrmw=bigfileset
    flowop appnd name=appnd1, iters=3, $filesetapd=bigfileset
    flowop statfile name=statfile1,filesetname=bigfileset,indexed=$fileidx
    flowop eventlimit name=ratecontrol
  }
}

echo  "NetworkFileServer Version 1.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>            defaults to $dir"
usage "       set \$cached=<bool>        defaults to $cached"
usage "       set \$eventrate=<value>    defaults to $eventrate"
usage "       set \$wrtiosize.type=<type>   defaults to $wrtiosize.type"
usage "       set \$wrtiosize.randsrc=<src> defaults to $wrtiosize.randsrc"
usage "       set \$rdiosize.type=<type>   defaults to $rdiosize.type"
usage "       set \$rdiosize.randsrc=<src> defaults to $rdiosize.randsrc"
usage "       set \$filesize.type=<type>   defaults to $filesize.type"
usage "       set \$filesize.randsrc=<src> defaults to $filesize.randsrc"
usage "       set \$nfiles=<value>       defaults to $nfiles"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage "       set \$sync=<bool>          defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $filesize=1g
set $nthreads=1
set $iosize=1m

define file name=largefile1,path=$dir,size=$filesize,prealloc,reuse
define file name=largefile2,path=$dir,size=$filesize,prealloc,reuse
define file name=largefile3,path=$dir,size=$filesize,prealloc,reuse
define file name=largefile4,path=$dir,size=$filesize,prealloc,reuse
define file name=largefile5,path=$dir,size=$filesize,prealloc,reuse

define process name=seqread,instances=1
{
  thread name=seqread1,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread1,filename=largefile1,iosize=$iosize
  }
  thread name=seqread2,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread2,filename=largefile2,iosize=$iosize
  }
  thread name=seqread3,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread3,filename=largefile3,iosize=$iosize
  }
  thread name=seqread4,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread4,filename=largefile4,iosize=$iosize
  }
  thread name=seqread5,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread5,filename=largefile5,iosize=$iosize
  }
}

echo  "Five Stream Read Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$filesize=<size>    defaults to $filesize"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       set \$iosize=<value> defaults to $iosize"
usage "       set \$directio=<bool> defaults to $directio"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded asynchronous ($sync) sequential writes (1MB I/Os) to
# a 1GB file.
# Stops after 1 series of 1024 ($count) writes has been done.

set $dir=/tmp
set $cached=false
set $count=1024
set $iosize=1m
set $nthreads=1
set $sync=false

define file name=bigfile,path=$dir,size=0,prealloc,cached=$cached

define process name=filewriter,instances=1
{
  thread name=filewriterthread,memsize=10m,instances=$nthreads
  {
    flowop appendfile name=write-file,dsync=$sync,filename=bigfile,iosize=$iosize,iters=$count
    flowop finishoncount name=finish,value=1
  }
}

echo  "FileMicro-SeqWrite Version 2.2 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$cached=<bool>    defaults to $cached"
usage "       set \$count=<value>    defaults to $count"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage "       set \$sync=<bool>      defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $filesize=5g
set $iosize=8k
set $nthreads=1
set $workingset=0
set $directio=0

define file name=largefile1,path=$dir,size=$filesize,prealloc,reuse,paralloc

define process name=rand-rw,instances=1
{
  thread name=rand-r-thread,memsize=5m,instances=$nthreads
  {
    flowop read name=rand-read1,filename=largefile1,iosize=$iosize,random,workingset=$workingset,directio=$directio
  }
  thread name=rand-w-thread,memsize=5m,instances=$nthreads
  {
    flowop write name=rand-write1,filename=largefile1,iosize=$iosize,random,workingset=$workingset,directio=$directio
  }
}

echo "Random RW Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>         defaults to $dir"
usage "       set \$filesize=<size>   defaults to $filesize"
usage "       set \$iosize=<value>    defaults to $iosize"
usage "       set \$nthreads=<value>  defaults to $nthreads"
usage "       set \$workingset=<value>  defaults to $workingset"
usage "       set \$directio=<bool>   defaults to $directio"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# Creates a fileset with $ndirs empty leaf directories then rmdir's all of them
#
set $dir=/tmp
set $ndirs=10000
set $meandirwidth=100
set $nthreads=16

set mode quit firstdone

define fileset name=bigfileset,path=$dir,size=0,leafdirs=$ndirs,dirwidth=$meandirwidth,prealloc

define process name=remdir,instances=1
{
  thread name=removedirectory,memsize=1m,instances=$nthreads
  {
    flowop removedir name=dirremover,filesetname=bigfileset
  }
}

echo  "RemoveDir Version 1.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>          defaults to $dir"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "       set \$ndirs=<value>      defaults to $ndirs"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "(sets mean dir width and dir depth is calculated as log (width, ndirs)"
usage " "
usage "       run"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

set $dir=/tmp
set $nfiles=1000
set $dirwidth=20
set $filesize=16k
set $nthreads=1
set $meaniosize=16k
set $readiosize=1m

set mode quit firstdone

define fileset name=postset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$dirwidth,prealloc,paralloc
define fileset name=postsetdel,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$dirwidth,prealloc,paralloc

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop openfile name=openfile1,filesetname=postset,fd=1
    flowop appendfilerand name=appendfilerand1,iosize=$meaniosize,fd=1
    flowop closefile name=closefile1,fd=1
    flowop openfile name=openfile2,filesetname=postset,fd=1
    flowop readwholefile name=readfile1,fd=1,iosize=$readiosize
    flowop closefile name=closefile2,fd=1
    flowop deletefile name=deletefile1,filesetname=postsetdel
  }
}

echo  "Mongo-like Version 2.3 personality successfully loaded"
usage "Usage: set \$dir=<dir>          defaults to $dir"
usage "       set \$filesize=<size>    defaults to $filesize"
usage "       set \$nfiles=<value>     defaults to $nfiles"
usage "       set \$dirwidth=<value>   defaults to $dirwidth"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       set \$meaniosize=<value> defaults to $meaniosize"
usage "       set \$readiosize=<size>  defaults to $readiosize"
usage " "
usage "       run"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded asynchronous random writes (8KB I/Os) on a 1GB file.
# A fsync is issued after 16K ($iters) worth of writes.
# Stops after one ($count) fsync.

set $dir=/tmp
set $cached=false
set $count=1
set $filesize=1g
set $iosize=8k
set $iters=16384
set $nthreads=1

define file name=bigfile,path=$dir,size=$filesize,prealloc,cached=$cached

define process name=filewriter,instances=1
{
  thread name=filewriterthread,memsize=10m,instances=$nthreads
  {
    flowop write name=write-file,filename=bigfile,random,iosize=$iosize,iters=$iters
    flowop fsync name=sync-file
    flowop finishoncount name=finish,value=$count
  }
}

echo  "FileMicro-WriteRandFsync Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$cached=<bool>    defaults to $cached"
usage "       set \$count=<value>    defaults to $count"
usage "       set \$filesize=<size>  defaults to $filesize"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$iters=<value>    defaults to $iters"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

#
# Creates a fileset of $nfiles number of files, then loops through them
# using $nthreads number of threads, doing "stat" calls on each file.
#

set $dir=/tmp
set $nfiles=10000
set $meandirwidth=20
set $filesize=128k
set $nthreads=20

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=100

define process name=examinefiles,instances=1
{
  thread name=examinefilethread, memsize=10m,instances=$nthreads
  {
    flowop statfile name=statfile1,filesetname=bigfileset
  }
}

echo  "Stat File Version 1.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>           defaults to $dir"
usage "       set \$filesize=<size>     defaults to $filesize"
usage "       set \$nfiles=<value>      defaults to $nfiles"
usage "       set \$nthreads=<value>    defaults to $nthreads"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "(sets mean dir width and dir depth is calculated as log (width, nfiles)"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $iosize=1m
set $nthreads=1

define file name=largefile1,path=$dir,prealloc

define process name=seqwrite,instances=1
{
  thread name=seqwrite,memsize=10m,instances=$nthreads
  {
    flowop write name=seqwrite,filename=largefile1,iosize=$iosize,directio
  }
}

echo  "Single Stream Direct Write Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$iosize=<value> defaults to $iosize"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded sequential reads (1MB I/Os) on a 1G file.

set $dir=/tmp
set $cached=false
set $filesize=1g
set $iosize=1m
set $nthreads=1

define file name=largefile,path=$dir,size=$filesize,prealloc,reuse,cached=$cached

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop read name=seqread-file,filename=largefile,iosize=$iosize
  }
}

echo  "FileMicro-SeqRead Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$cached=<bool>    defaults to $cached"
usage "       set \$filesize=<size>  defaults to $filesize"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded appends/writes (8KB I/Os) to a 1GB file.
# Each loop iteration does a fsync after 1250 ($iters) appends.
# Stops after 128K ($count) appends have been done.

set $dir=/tmp
set $count=128k
set $iosize=8k
set $iters=1250
set $nthreads=1

define file name=bigfile,path=$dir,size=0,prealloc

define process name=filecreater,instances=1
{
  thread name=filecreaterthread,memsize=10m,instances=$nthreads
  {
    flowop appendfile name=append-file,filename=bigfile,iosize=$iosize,iters=$iters
    flowop fsync name=sync-file
    flowop finishoncount name=finish,value=$count
  }
}

echo  "FileMicro-WriteFsync Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$count=<value>    defaults to $count"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$iters=<value>    defaults to $iters"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $nfiles=1000
set $meandirwidth=1000000
set $meanfilesize=16k
set $nthreads=16
set $iosize=1m
set $meanappendsize=16k

define fileset name=bigfileset,path=$dir,size=$meanfilesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=80

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop deletefile name=deletefile1,filesetname=bigfileset
    flowop createfile name=createfile2,filesetname=bigfileset,fd=1
    flowop appendfilerand name=appendfilerand2,iosize=$meanappendsize,fd=1
    flowop fsync name=fsyncfile2,fd=1
    flowop closefile name=closefile2,fd=1
    flowop openfile name=openfile3,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile3,fd=1,iosize=$iosize
    flowop appendfilerand name=appendfilerand3,iosize=$meanappendsize,fd=1
    flowop fsync name=fsyncfile3,fd=1
    flowop closefile name=closefile3,fd=1
    flowop openfile name=openfile4,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile4,fd=1,iosize=$iosize
    flowop closefile name=closefile4,fd=1
  }
}

echo  "Varmail Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$meanfilesize=<size>    defaults to $meanfilesize"
usage "       set \$nfiles=<value>     defaults to $nfiles"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       set \$meanappendsize=<value> defaults to $meanappendsize"
usage "       set \$iosize=<size>  defaults to $iosize"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Creates a fileset with 20,000 entries ($nfiles), but only preallocates
# 50% of the files.  Each file's size is set via a gamma distribution with
# a median size of 1KB ($filesize).
#
# The single thread then creates a new file and writes the whole file with
# 1MB I/Os.  The thread stops after 5000 files ($count/num of flowops) have
# been created and written to.

set $dir=/tmp
set $count=15000
set $filesize=1k
set $iosize=1m
set $meandirwidth=100000
set $nfiles=20000
set $nthreads=1

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=50

define process name=filecreate,instances=1
{
  thread name=filecreatethread,memsize=10m,instances=$nthreads
  {
    flowop createfile name=createfile1,filesetname=bigfileset,fd=1
    flowop writewholefile name=writefile1,filesetname=bigfileset,fd=1,iosize=$iosize
    flowop closefile name=closefile1,fd=1
    flowop finishoncount name=finish,value=$count
  }
}

echo  "FileMicro-Createfiles Version 2.2 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$count=<value>        defaults to $count"
usage "       set \$filesize=<size>      defaults to $filesize"
usage "       set \$iosize=<size>        defaults to $iosize"
usage "       set \$meandirwidth=<value> defaults to $meandirwidth"
usage "       set \$nfiles=<value>       defaults to $nfiles"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Create a fileset of 50,000 entries ($nfiles), where each file's size is set
# via a gamma distribution with the median size of 16KB ($filesize).
# Fire off 16 threads ($nthreads), where each thread stops after
# deleting 1000 ($count) files.

set $dir=/tmp
set $count=1000
set $filesize=16k
set $nfiles=5000
set $meandirwidth=100
set $nthreads=16

set mode quit firstdone

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=100,paralloc

define process name=filedelete,instances=1
{
  thread name=filedeletethread,memsize=10m,instances=$nthreads
  {
    flowop deletefile name=deletefile1,filesetname=bigfileset
    flowop opslimit name=limit
    flowop finishoncount name=finish,value=$count
  }
}

echo  "FileMicro-Delete Version 2.4 personality successfully loaded"
usage "Usage: set \$dir=<dir>           defaults to $dir"
usage "       set \$count=<value>       defaults to $count"
usage "       set \$filesize=<size>     defaults to $filesize"
usage "       set \$nfiles=<value>      defaults to $nfiles"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "       set \$nthreads=<value>    defaults to $nthreads"
usage "(sets mean dir width and dir depth is calculated as log (width, nfiles)"
usage " "
usage "       run"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $eventrate=0
set $runtime=30
set $iosize=2k
set $nshadows=200
set $ndbwriters=10
set $usermode=200000
set $filesize=10m
set $memperthread=1m
set $workingset=0
set $cached=0
set $logfilesize=10m
set $nfiles=10
set $nlogfiles=1
set $directio=0

eventgen rate = $eventrate

# Define a datafile and logfile
define fileset name=datafiles,path=$dir,size=$filesize,filesizegamma=0,entries=$nfiles,dirwidth=1024,prealloc=100,cached=$cached,reuse
define fileset name=logfile,path=$dir,size=$logfilesize,filesizegamma=0,entries=$nlogfiles,dirwidth=1024,prealloc=100,cached=$cached,reuse

define process name=lgwr,instances=1
{
  thread name=lgwr,memsize=$memperthread,useism
  {
    flowop aiowrite name=lg-write,filesetname=logfile,
        iosize=256k,random,directio=$directio,dsync
    flowop aiowait name=lg-aiowait
    flowop semblock name=lg-block,value=3200,highwater=1000
  }
}

# Define database writer processes
define process name=dbwr,instances=$ndbwriters
{
  thread name=dbwr,memsize=$memperthread,useism
  {
    flowop aiowrite name=dbwrite-a,filesetname=datafiles,
        iosize=$iosize,workingset=$workingset,random,iters=100,opennext,directio=$directio,dsync
    flowop hog name=dbwr-hog,value=10000
    flowop semblock name=dbwr-block,value=1000,highwater=2000
    flowop aiowait name=dbwr-aiowait
  }
}

define process name=shadow,instances=$nshadows
{
  thread name=shadow,memsize=$memperthread,useism
  {
    flowop read name=shadowread,filesetname=datafiles,
      iosize=$iosize,workingset=$workingset,random,opennext,directio=$directio
    flowop hog name=shadowhog,value=$usermode
    flowop sempost name=shadow-post-lg,value=1,target=lg-block,blocking
    flowop sempost name=shadow-post-dbwr,value=1,target=dbwr-block,blocking
    flowop eventlimit name=random-rate
  }
}

echo "OLTP Version 3.0  personality successfully loaded"
usage "Usage: set \$dir=<dir>         defaults to $dir"
usage "       set \$eventrate=<value> defaults to $eventrate"
usage "       set \$filesize=<size>   defaults to $filesize, n.b. there are ten files of this size"
usage "       set \$logfilesize=<size> defaults to $logfilesize, n.b. there is one file of this size"
usage "       set \$iosize=<value>    defaults to $iosize, typically 2k or 8k"
usage "       set \$cached=<bool>     defaults to $cached"
usage "       set \$memperthread=<value> defaults to $memperthread"
usage "       set \$directio=<value>  defaults to $directio"
usage "       run runtime (e.g. run 60)"
usage "Note - total filesize should be at least 2x physical memory size for conforming test)"
usage "       i.e. if physmem = 4G, set filesize to 4G * 2 / 10, or 800m"
usage "Note - this workload needs at least 512MB of of memory"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

set $dir=/tmp
set $nfiles=50000
set $meandirwidth=100
set $meanfilesize=16k
set $iosize=1m
set $nthreads=16

set mode quit firstdone

define fileset name=bigfileset,path=$dir,size=$meanfilesize,entries=$nfiles,dirwidth=$meandirwidth

define process name=filecreate,instances=1
{
  thread name=filecreatethread,memsize=10m,instances=$nthreads
  {
    flowop createfile name=createfile1,filesetname=bigfileset,fd=1
    flowop writewholefile name=writefile1,fd=1,iosize=$iosize
    flowop closefile name=closefile1,fd=1
  }
}

echo  "Createfiles Version 3.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>          defaults to $dir"
usage "       set \$meanfilesize=<size>    defaults to $meanfilesize"
usage "       set \$iosize=<size>      defaults to $iosize"
usage "       set \$nfiles=<value>     defaults to $nfiles"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "       run"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# Exercises the indexed attribute of the fileset_pick() function. 
# 

set $dir=/tmp
set $cached=false
set $meandirwidth=20
set $nthreads=5
set $nfiles=10000
set $sync=false

define randvar name=$wrtiosize, min=512, round=512, type=gamma, mean=16k

define randvar name=$rdiosize, type=tabular, min=8k, round=1k, randtable =
{{85,   8k,  8k},
 {15,   8k, 64k}
}

define randvar name=$filesize, type=tabular, min=1k, randtable =
{{33,   1k,    1k},
 {21,   1k,    3k},
 {13,   3k,    5k},
 {10,   5k,   11k},
 {08,  11k,   21k},
 {05,  21k,   43k},
 {04,  43k,   85k},
 {03,  85k,  171k},
 {02, 171k,  341k},
 {01, 341k, 1707k}
}

define randvar name=$fileidx, type=gamma, min=0, gamma=100

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$meandirwidth,prealloc=100,cached=$cached

define process name=netclient,instances=1
{
  thread name=fileuser,memsize=10m,instances=$nthreads
  {
    flowop openfile name=openfile1,filesetname=bigfileset,indexed=$fileidx,fd=1
    flowop openfile name=openfile2,filesetname=bigfileset,indexed=$fileidx,fd=2
    flowop openfile name=openfile3,filesetname=bigfileset,indexed=$fileidx,fd=3
    flowop appendfilerand name=appendfilerand1,iosize=$wrtiosize,fd=1
    flowop closefile name=closefile1,fd=1
    flowop readwholefile name=readfile1,iosize=$rdiosize,fd=2
    flowop readwholefile name=readfile2,iosize=$rdiosize,fd=3
    flowop closefile name=closefile2,fd=2
    flowop closefile name=closefile3,fd=3
  }
}

echo  "NetworkServer Version 1.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>            defaults to $dir"
usage "       set \$cached=<bool>        defaults to $cached"
usage "       set \$wrtiosize.type=<type>   defaults to $wrtiosize.type"
usage "       set \$wrtiosize.randsrc=<src> defaults to $wrtiosize.randsrc"
usage "       set \$wrtiosize.mean=<mean>   defaults to $wrtiosize.mean"
usage "       set \$wrtiosize.gamma=<gamma> defaults to $wrtiosize.gamma"
usage "       set \$rdiosize.type=<type>   defaults to $rdiosize.type"
usage "       set \$rdiosize.randsrc=<src> defaults to $rdiosize.randsrc"
usage "       set \$filesize.type=<type>   defaults to $filesize.type"
usage "       set \$filesize.randsrc=<src> defaults to $filesize.randsrc"
usage "       set \$nfiles=<value>       defaults to $nfiles"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage "       set \$sync=<bool>          defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# Creates a fileset with $nfiles empty files, then proceeds to open each one
# and then close it.
#
set $dir=/tmp
set $nfiles=50000
set $meandirwidth=100
set $nthreads=16

define fileset name=bigfileset,path=$dir,size=0,entries=$nfiles,dirwidth=$meandirwidth,prealloc

define process name=fileopen,instances=1
{
  thread name=fileopener,memsize=1m,instances=$nthreads
  {
    flowop openfile name=open1,filesetname=bigfileset,fd=1
    flowop closefile name=close1,fd=1
  }
}

echo  "Openfiles Version 1.0 personality successfully loaded"
usage "Usage: set \$dir=<dir>          defaults to $dir"
usage "       set \$meandirwidth=<size> defaults to $meandirwidth"
usage "       set \$nfiles=<value>     defaults to $nfiles"
usage "       set \$nthreads=<value>   defaults to $nthreads"
usage "(sets mean dir width and dir depth is calculated as log (width, nfiles)"
usage " "
usage "       run 60"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

# RateLimCopyFiles.f uses the iopslimit flowop with the target attribute
# set to the writewholefile flowop to limit the rate to one writewholefile
# operation per event. Without the target attribute set, the limit will
# be one writewholefile OR readwholefile operation per event, so in effect
# it will run at half the rate. Without the target attribute, this workload
# is identical to copyfiles.f. Set the event generator rate by setting
# the $eventrate variable, for instance by typing:
#     set $eventrate=20
# at the filebench prompt to get twenty events per second.
#

# $dir - directory for datafiles
# $eventrate - event generator rate (0 == free run)
# $filesize - size of data file
# $iosize - size of each I/O request
# $nfiles - number of files in the fileset
# $nthreads - number of worker threads

set $dir=/tmp
set $eventrate=10
set $dirwidth=20
set $filesize=16k
set $iosize=1m
set $nfiles=1000
set $nthreads=1

eventgen rate=$eventrate
set mode quit firstdone

define fileset name=bigfileset,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$dirwidth,prealloc=100
define fileset name=destfiles,path=$dir,size=$filesize,entries=$nfiles,dirwidth=$dirwidth

define process name=filereader,instances=1
{
  thread name=filereaderthread,memsize=10m,instances=$nthreads
  {
    flowop openfile name=openfile1,filesetname=bigfileset,fd=1
    flowop readwholefile name=readfile1,fd=1,iosize=$iosize
    flowop createfile name=createfile2,filesetname=destfiles,fd=2
    flowop writewholefile name=writefile2,filesetname=destfiles,fd=2,srcfd=1,iosize=$iosize
    flowop closefile name=closefile1,fd=1
    flowop closefile name=closefile2,fd=2
    flowop iopslimit name=iopslim1, target=writefile2
  }
}

echo  "RateLimCopyFiles Version 1.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>         defaults to $dir"
usage "       set \$eventrate=<value> defaults to $eventrate"
usage "       set \$filesize=<size>   defaults to $filesize"
usage "       set \$nfiles=<value>    defaults to $nfiles"
usage "       set \$iosize=<size>     defaults to $iosize"
usage "       set \$dirwidth=<value>  defaults to $dirwidth"
usage "       set \$nthreads=<value>  defaults to $nthreads"
usage " "
usage "       run"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.

# Sequential write() of a 1G file, size picked from a gamma distribution
# min of 1k and a mean of 5.5K, followed by close(), cached.



set $dir=/tmp
set $nthreads=1
set $cached=false
set $sync=false
set $count=128k

define randvar name=$iosize, type=gamma, min=1k, mean=5632, gamma=1500

define fileset name=bigfileset,path=$dir,size=0,entries=$nthreads,dirwidth=1024,prealloc=100,cached=$cached

define process name=filewriter,instances=1
{
  thread name=filewriterthread,memsize=10m,instances=$nthreads
  {
    flowop openfile name=open-file,filesetname=bigfileset,fd=1
    flowop appendfile name=write-file,dsync=$sync,iosize=$iosize,fd=1,iters=$count
    flowop closefile name=close,fd=1
    flowop finishoncount name=finish,value=1
  }
}

echo  "FileMicro-SeqWriteRandVarGam Version 1.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$cached=<bool>        defaults to $cached"
usage "       set \$count=<value>        defaults to $count"
usage "       set \$iosize.type=<type>   defaults to $iosize.type"
usage "       set \$iosize.randsrc=<src> defaults to $iosize.randsrc"
usage "       set \$iosize.mean=<mean>   defaults to $iosize.mean"
usage "       set \$iosize.gamma=<gamma> defaults to $iosize.gamma"
usage "       set \$nthreads=<value>     defaults to $nthreads"
usage "       set \$sync=<bool>          defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#

# $dir - directory for datafiles
# $eventrate - event generator rate (0 == free run)
# $iosize - iosize for database block access
# $nshadows - number of shadow processes
# $ndbwriters - number of database writers

set $dir=/tmp
set $eventrate=0
set $iosize=2k
set $nshadows=200
set $ndbwriters=10
set $runtime=30
set $usermode=20000
set $memperthread=1m

debug 1
eventgen rate=$eventrate

# Define a datafile and logfile
define file name=aux.df,path=$dir,size=251m,reuse,prealloc,paralloc
define file name=control_001,path=$dir,size=2m,reuse,prealloc,paralloc
define file name=cust_0_0,path=$dir,size=6704m,reuse,prealloc,paralloc
define file name=cust_0_1,path=$dir,size=6704m,reuse,prealloc,paralloc
define file name=cust_0_2,path=$dir,size=6704m,reuse,prealloc,paralloc
define file name=cust_0_3,path=$dir,size=6704m,reuse,prealloc,paralloc
define file name=dist_0_0,path=$dir,size=31m,reuse,prealloc,paralloc
define file name=hist_0_0,path=$dir,size=3002m,reuse,prealloc,paralloc
define file name=icust1_0_0,path=$dir,size=4943m,reuse,prealloc,paralloc
define file name=icust2_0_0,path=$dir,size=4943m,reuse,prealloc,paralloc
define file name=idist_0_0,path=$dir,size=11m,reuse,prealloc,paralloc
define file name=iitem_0_0,path=$dir,size=11m,reuse,prealloc,paralloc
define file name=iordr2_0_0,path=$dir,size=1651m,reuse,prealloc,paralloc
define file name=istok_0_0,path=$dir,size=2262m,reuse,prealloc,paralloc
define file name=item_0_0,path=$dir,size=21m,reuse,prealloc,paralloc
define file name=iware_0_0,path=$dir,size=11m,reuse,prealloc,paralloc
define file name=nord_0_0,path=$dir,size=561m,reuse,prealloc,paralloc
define file name=ordr_0_0,path=$dir,size=44301m,reuse,prealloc,paralloc
define file name=roll1,path=$dir,size=2001m,reuse,prealloc,paralloc
define file name=sp_0,path=$dir,size=1001m,reuse,prealloc,paralloc
define file name=stok_0_0,path=$dir,size=8052m,reuse,prealloc,paralloc
define file name=stok_0_1,path=$dir,size=8052m,reuse,prealloc,paralloc
define file name=stok_0_2,path=$dir,size=8052m,reuse,prealloc,paralloc
define file name=stok_0_3,path=$dir,size=8052m,reuse,prealloc,paralloc
define file name=stok_0_4,path=$dir,size=8052m,reuse,prealloc,paralloc
define file name=system_1,path=$dir,size=401m,reuse,prealloc,paralloc
define file name=temp_0_0,path=$dir,size=4943m,reuse,prealloc,paralloc
define file name=temp_0_1,path=$dir,size=4943m,reuse,prealloc,paralloc
define file name=ware_0_0,path=$dir,size=11m,reuse,prealloc,paralloc
define file name=log_1_1,path=$dir,size=1021m,reuse,prealloc,paralloc

# Define database writer processes
define process name=dbwr,instances=$ndbwriters
{
  thread name=dbwr,memsize=$memperthread,useism
  {
	flowop aiowrite name=dbaiowrite-aux.df,filename=aux.df,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-control_001,filename=control_001,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-cust_0_0,filename=cust_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-cust_0_1,filename=cust_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-cust_0_2,filename=cust_0_2,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-cust_0_3,filename=cust_0_3,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-dist_0_0,filename=dist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-hist_0_0,filename=hist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-icust1_0_0,filename=icust1_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-icust2_0_0,filename=icust2_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-idist_0_0,filename=idist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-iitem_0_0,filename=iitem_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-iordr2_0_0,filename=iordr2_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-istok_0_0,filename=istok_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-item_0_0,filename=item_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-iware_0_0,filename=iware_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-nord_0_0,filename=nord_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-ordr_0_0,filename=ordr_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-roll1,filename=roll1,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-sp_0,filename=sp_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-stok_0_0,filename=stok_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-stok_0_1,filename=stok_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-stok_0_2,filename=stok_0_2,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-stok_0_3,filename=stok_0_3,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-stok_0_4,filename=stok_0_4,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-system_1,filename=system_1,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-temp_0_0,filename=temp_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-temp_0_1,filename=temp_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
        flowop aiowrite name=dbaiowrite-ware_0_0,filename=ware_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio,iters=10
	flowop hog name=dbwr-hog,value=10000
	flowop semblock name=dbwr-block,value=100,highwater=10000
	flowop aiowait name=dbwr-aiowait
  }
}

define process name=lgwr,instances=1
{
  thread name=lgwr,memsize=$memperthread,useism
  {
    flowop write name=lg-write,filename=log_1_1,
        iosize=256k,workingset=1g,random,dsync,directio
#   flowop delay name=lg-delay,value=1
    flowop semblock name=lg-block,value=320,highwater=1000
  }
}

define process name=shadow,instances=$nshadows
{
  thread name=shadow,memsize=$memperthread,useism
  {
        flowop read name=shadowread-aux.df,filename=aux.df,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-control_001,filename=control_001,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-cust_0_0,filename=cust_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-cust_0_1,filename=cust_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-cust_0_2,filename=cust_0_2,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-cust_0_3,filename=cust_0_3,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-dist_0_0,filename=dist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-hist_0_0,filename=hist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-icust1_0_0,filename=icust1_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-icust2_0_0,filename=icust2_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-idist_0_0,filename=idist_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-iitem_0_0,filename=iitem_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-iordr2_0_0,filename=iordr2_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-istok_0_0,filename=istok_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-item_0_0,filename=item_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-iware_0_0,filename=iware_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-nord_0_0,filename=nord_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-ordr_0_0,filename=ordr_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-roll1,filename=roll1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-sp_0,filename=sp_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-stok_0_0,filename=stok_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-stok_0_1,filename=stok_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-stok_0_2,filename=stok_0_2,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-stok_0_3,filename=stok_0_3,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-stok_0_4,filename=stok_0_4,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-system_1,filename=system_1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-temp_0_0,filename=temp_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-temp_0_1,filename=temp_0_1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-ware_0_0,filename=ware_0_0,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
        flowop read name=shadowread-log_1_1,filename=log_1_1,
                iosize=$iosize,workingset=10g,random,dsync,directio
        flowop hog name=shadowhog,value=$usermode
	flowop sempost name=shadow-post-lg,value=1,target=lg-block,blocking
	flowop sempost name=shadow-post-dbwr,value=1,target=dbwr-block,blocking
	flowop eventlimit name=random-rate
  }
}

echo "Tpcso Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>         defaults to $dir"
usage " "
usage "       set \$eventrate=<value> defaults to $eventrate"
usage " "
usage "       set \$iosize=<value>    defaults to $iosize, typically 2k or 8k"
usage " "
usage "       set \$memperthread=<value> defaults to $memperthread, there are 211 threads"
usage " "
usage "       run runtime (e.g. run 60)"
usage " "
usage "Note - this workload needs at least 512MB of of memory"
usage " "

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"%Z%%M%	%I%	%E% SMI"

# Single threaded asynchronous ($sync) random writes (2KB I/Os) on a 1GB file.
# Stops when 128MB ($bytes) has been written.

set $dir=/tmp
set $bytes=128m
set $cached=false
set $filesize=1g
set $iosize=2k
set $iters=1
set $nthreads=1
set $sync=false

define file name=bigfile1,path=$dir,size=$filesize,prealloc,reuse,cached=$cached

define process name=filewriter,instances=1
{
  thread name=filewriterthread,memsize=10m,instances=$nthreads
  {
    flowop write name=write-file,filename=bigfile1,random,dsync=$sync,iosize=$iosize,iters=$iters
    flowop finishonbytes name=finish,value=$bytes
  }
}

echo  "FileMicro-WriteRand Version 2.1 personality successfully loaded"
usage "Usage: set \$dir=<dir>"
usage "       set \$bytes=<value>    defaults to $bytes"
usage "       set \$cached=<bool>    defaults to $cached"
usage "       set \$filesize=<size>  defaults to $filesize"
usage "       set \$iosize=<size>    defaults to $iosize"
usage "       set \$iters=<value>    defaults to $iters"
usage "       set \$nthreads=<value> defaults to $nthreads"
usage "       set \$sync=<bool>      defaults to $sync"
usage " "
usage "       run runtime (e.g. run 60)"
